#ifndef PSO_H
#define PSO_H
# include <problem.h>

class Pso
{
private:
    QVector<Data> particle;
    QVector<Data> bestParticle;
    Data    fitnessArray;
    Data    bestFitnessArray;
    QVector<Data> velocity;
    Data    bestg;
    double  bestf;
    Problem *problem;
    double c1,c2;
    double weight;
public:
    Pso(int count,Problem *p);
    void    setweight(double w);
    double  getweight() const;
    void    setc1(double c);
    void    setc2(double c);
    double  getc1() const;
    double  getc2() const;
    void    nextGeneration();
    Data    getBest();
    double  getBestFitness();
    void    getParticle(int index,Data &x,double &y);
};

#endif // PSO_H
